function [hat_x,info] = alg_LSAPCVB_x0(y,M,iterations,tlacitko,x_0)

[p n] = size(M);
pos = 1;

%% aktivni indexy v L (krome diagonaly, tu vynechavam)
indL = zeros(n,n);
s = 2; % delka nenuloveho bloku (vcetne hl. diagonaly, tam je napevno 1)
r = 1; % pocet bloku

if 1
    blok = [ones(1,s) zeros(1,n/r-s)];
    indDiag = kron(ones(1,r),blok);
else
    blok = [ones(1,s) zeros(1,n/r-s)];
    blok2 = [ones(1,s-1) zeros(1,n/r-s+1)];
    indDiag = kron(ones(1,r) - [0 ones(1,r-1)],blok) + kron(ones(1,r) - [1 zeros(1,r-1)],blok2);
end
% keyboard
for j = 1:(n) % iterace pres diagonaly (tam se neco deje)
    if indDiag(j)
        indL = indL + diag(ones(n-j+1,1),j-1);
    end
end
indL = indL' - eye(n); % odectu hlavni diagonalu, tam v L nic nepocitam...
% figure; imagesc(indL); error
% keyboard


%% start data
hat_upsilon = tlacitko*ones(n,1);%tlacitko*1*ones(n,1);
hat_L = -0.0*indL + eye(n);
hat_omega = 1*max(max(M'*M))^(-1);
hat_x = ones(n,1);

Dsi_lj = ones(n,n);

% varsigma bude matice ve stejnem tvaru jako hat_L, bude se s tim lip pracovat...
hat_varsigma = 1*indL;
hat_LLt = hat_L*hat_L' + 0*eye(n);

koef_el0 = -1;
% koef_el0 = -tlacitko;
eL0 = zeros(n,n) + koef_el0*diag(ones(n-1,1),-1);
% eL0 = koef_el0*indL;

% keyboard

% zda se budu vycislovat i LM pro model selection
model_selection = 1;


%% prior
prior_ups = 1;
switch prior_ups
    case 1 % normalni
        alpha0 = 1e-10;
        beta0 = 1e-10;
end
fixedSigmaL = 0;
if fixedSigmaL
    zeta0 = 4e10;
    eta0 = 1e10;
else
    zeta0 = 1e-2; 
    eta0 = 1e-2;
end
vartheta0 = 1e-10;
rho0 = 1e-10;


pomLULt = 0*eye(n);
pomLtxxtL = zeros(n,1);
pomLtxx0tL = zeros(n,1);
pomLtx0x0tL = zeros(n,1);
pomLtx0xtL = zeros(n,1);
hat_x0x0t = x_0*x_0';

info.omega = zeros(iterations,1);

% keyboard
% predpocitani
MtM = M'*M;
yty = y'*y;
ytM = y'*M;
Mty = M'*y;

%% vypocet
konec = 1;
iter = 0;
while konec
    iter = iter + 1;
    if mod(iter,50) == 0
        display(['LS-APC-VB with x0: iteration ' num2str(iter) '/' num2str(iterations)])    
    end


    %% x
%     pomLULt = zeros(n,n); 
%     si_x = (hat_omega*M'*M + hat_L*diag(hat_upsilon)*hat_L' + pLULt)^(-1); % krizove cleny
    si_x = (hat_omega*MtM + hat_L*diag(hat_upsilon)*hat_L' + pomLULt )^(-1);
    mu_x = si_x*(hat_omega*Mty + (hat_L*diag(hat_upsilon)*hat_L' + pomLULt)*x_0);
    
%     keyboard
    
    if pos
        [hat_x hat_xx] = momtrun_low(mu_x,sqrt(diag( si_x )),0);
        var_x = hat_xx - hat_x.^2;
        hat_xxt = hat_x*hat_x' + diag(var_x);
        if 1
            old_dSi = diag(si_x);
            new_dSi = var_x;
            nasobic = diag(sqrt(new_dSi./old_dSi));
            new_si_x = nasobic*si_x*nasobic;
            hat_xxt = hat_x*hat_x' + new_si_x;
        end
    else
        hat_x = mu_x;
        hat_xxt = mu_x*mu_x' + si_x;
    end    
%     keyboard
    % bude se hodit...
    hat_xx0t = hat_x*x_0';
    hat_x0xt = x_0*hat_x';

    %% upsilon
%     pomLtxxtL = zeros(n,n);
    alpha = alpha0 + (1/2)*ones(n,1);
    
    for j = 1:(n-1)
        ind = find(indL(:,j)>0);
        %%% !!!!! ma byt neco ala trace(si_lj*hat_xxt(ind,ind)); 
        pomLtxxtL(j) = hat_L([j; ind],j)'*hat_xxt([j; ind],[j; ind])*hat_L([j; ind],j) + trace(diag(Dsi_lj(ind,j))*hat_xxt(ind,ind)); 
        
        pomLtxx0tL(j) = hat_L([j; ind],j)'*hat_xx0t([j; ind],[j; ind])*hat_L([j; ind],j) + trace(diag(Dsi_lj(ind,j))*hat_xx0t(ind,ind));
        pomLtx0xtL(j) = hat_L([j; ind],j)'*hat_x0xt([j; ind],[j; ind])*hat_L([j; ind],j) + trace(diag(Dsi_lj(ind,j))*hat_x0xt(ind,ind));
        pomLtx0x0tL(j) = hat_L([j; ind],j)'*hat_x0x0t([j; ind],[j; ind])*hat_L([j; ind],j) + trace(diag(Dsi_lj(ind,j))*hat_x0x0t(ind,ind));
    end
    pomLtxxtL(n) = hat_xxt(n,n);
    pomLtxx0tL(n) = hat_xx0t(n,n);
    pomLtx0xtL(n) = hat_x0xt(n,n);
    pomLtx0x0tL(n) = hat_x0x0t(n,n);
    
    beta = beta0 + (1/2)*(pomLtxxtL - pomLtx0xtL - pomLtxx0tL + pomLtx0x0tL);
    hat_upsilon = alpha./beta;
    
    
    si_LLt = zeros(n);
    pomLULt = zeros(n);
%     pomLtxxtL = zeros(n);
    %% l + varsigma
    % hat_L je dolni trojuhelnikova matice
    lm4 = 0;
    lm5 = 0;

    for j = 1:(n-1)
%         keyboard
        ind = find(indL(:,j)>0); % indexy, kde se bude neco dit...
        

        si_lj = (hat_upsilon(j)*hat_xxt(ind,ind) + diag(hat_varsigma(ind,j)) -hat_upsilon(j)*hat_x0xt(ind,ind) -hat_upsilon(j)*hat_xx0t(ind,ind) + hat_upsilon(j)*hat_x0x0t(ind,ind))^(-1);
%         keyboard
%         mu_lj = si_lj*(-hat_upsilon(j)*(hat_xxt(ind,j) ) + diag(hat_varsigma(ind,j))*eL0(ind,j) +2*hat_upsilon(j)*hat_xx0t(ind,j) -hat_upsilon(j)*hat_x0x0t(ind,j));
        mu_lj = si_lj*(-hat_upsilon(j)*(hat_xxt(ind,j) ) + diag(hat_varsigma(ind,j))*eL0(ind,j) + hat_upsilon(j)*hat_x0xt(ind,j) + hat_upsilon(j)*hat_xx0t(ind,j) -hat_upsilon(j)*hat_x0x0t(ind,j));
        
        if (iter == 13) && (0)
            keyboard
        end
        
        hat_lj = mu_lj;
        hat_ljljt = mu_lj*mu_lj' + si_lj;
        hat_ljtlj = mu_lj'*mu_lj + sum(diag(si_lj));
        
        hat_L(ind,j) = hat_lj;
        
        Dsi_lj(ind,j) = diag(si_lj);
        
        % varsigma(j)
        zeta = zeta0 + (1/2);
%         keyboard
        eta = eta0 + (1/2)*diag(hat_ljljt) - diag(eL0(ind,j)*hat_lj') + (1/2)*diag(eL0(ind,j)*eL0(ind,j)');
        hat_varsigma(ind,j) = zeta./eta; % velka matice, podobna hat_L bez diagonaly
%         keyboard


        % vytvorim si matici LLt
        si_LLt(ind,ind) = si_lj;
        pomLULt(ind,ind) = pomLULt(ind,ind) + si_lj*hat_upsilon(j); % pomocna matice pro x
        
%         if any(eig(si_lj)<0)
%             keyboard
%         end

%         % pomocna matice pro upsilon, zajima nas jen diagonala...zefektivnit...
%         % uz je to primo u upsilon
%         si_L = zeros(n);
%         si_L(ind,ind) = si_lj;
% %         pomLtxxtL(j,j) = hat_L(:,j)'*hat_xxt*hat_L(:,j) + trace(si_L*hat_xxt); % neefektivni
%         pomLtxxtL(j,j) = hat_L([j; ind],j)'*hat_xxt([j; ind],[j; ind])*hat_L([j; ind],j) + trace(si_lj*hat_xxt(ind,ind));
% %         keyboard

        %% model selection
        if model_selection
            if iter == iterations
                dvarsigmaj = zeta./eta;
                eL0j = eL0(ind,j);
    %             lm4 = lm4 - (1/2)*( (hat_lj'*dvarsigmaj*hat_lj + sum(diag(dvarsigmaj*si_lj))) - 2*eL0j'*dvarsigmaj*hat_lj + eL0j'*dvarsigmaj*eL0j );
                lm4 = lm4 - (1/2)*( (hat_lj'*dvarsigmaj*hat_lj + sum(diag(dvarsigmaj*si_lj))) - eL0j'*dvarsigmaj*hat_lj - hat_lj'*dvarsigmaj*eL0j + eL0j'*dvarsigmaj*eL0j );
                lm4 = lm4 + (1/2)*log(det(si_lj)) + (1/2)*( trace(hat_ljljt*si_lj^(-1)) - mu_lj'*si_lj^(-1)*hat_lj - hat_lj'*si_lj^(-1)*mu_lj + mu_lj'*si_lj^(-1)*mu_lj );
    %             keyboard

                mi = 1;
                dl0lj = diag(eL0j*hat_lj');
                dl0l0 = diag(eL0j*eL0j');
                for m = ind
                    lm5 = lm5 - zeta*log(eta(mi)) + ( (1/2)*hat_ljljt(mi,mi) - dl0lj(mi) + (1/2)*dl0l0(mi) )*dvarsigmaj(mi);

                    mi = mi + 1;
                end
            end
        end


    end
        if 0
            varsigma_pom = 1./mean(1./diag(hat_varsigma,-1));
            hat_varsigma = diag(ones(n-1,1)*varsigma_pom,-1);
        end
%     pomLtxxtL(n,n) = hat_xxt(n,n);
    
    hat_LLt = hat_L*hat_L' + si_LLt;
    
%     keyboard





% end

  
    
%     keyboard
    
    %% omega
    vartheta = vartheta0 + p/2;
    rho = rho0 + (1/2)*trace(hat_xxt*MtM) - ytM*hat_x + (1/2)*yty;
    hat_omega = vartheta/rho;
    
    info.omega(iter) = hat_omega;   
    
    


    if iter == iterations
        konec = 0;
%         keyboard
    end
end

%% model selection
if model_selection
    % y a omega
    lm1 = -vartheta*log(rho);
    % lm1 = 0;
    % keyboard

    % x
    lm2 = 0;
    % for j = 1:n
    %     pom = + log( 1 - erf( (-mu_x(j))/sqrt(2*si_x(j,j)) ) );
    %     if pom == -inf
    %         pom = 0;
    %     end
    %     lm2 = lm2 + 1/(2*si_x(j,j))*( -2*hat_x(j)*mu_x(j)+mu_x(j)^2 ) + pom;
    % end
    Si_x_0 = (hat_L*diag(hat_upsilon)*hat_L' + pomLULt)^(-1); % (LUL')^(-1)
    for j = 1:n
        pom = + log( 1 - erf( (-mu_x(j))/sqrt(2*si_x(j,j)) ) );
        if pom == -inf
            pom = 0;
            disp('!')
    %         keyboard
        end
        pom2 = + log( 1 - erf( (-x_0(j))/sqrt(2*Si_x_0(j,j)) ) );
        if isinf(pom2)
            pom2 = 0;
            disp('!')
        end

        si_xj_0 = Si_x_0(j,j); % (LUL')^(-1)_jj

        lm2 = lm2 - ( hat_xxt(j,j) - 2*hat_x(j)*x_0(j) + x_0(j)^2 )/(2*si_xj_0) - log(sqrt(pi*si_xj_0)) + log(sqrt(pi*si_x(j,j))) + 1/(2*si_x(j,j))*(+hat_xxt(j,j)-2*hat_x(j)*mu_x(j)+mu_x(j)^2 ) + pom - pom2;
        if isnan(lm2)
            keyboard
        end
    %     graf(j) = - hat_xxt(j,j)/(2*si_xj_0) - log(sqrt(pi*si_xj_0)) + log(sqrt(pi*si_x(j,j))) + 1/(2*si_x(j,j))*(+hat_xxt(j,j)-2*hat_x(j)*mu_x(j)+mu_x(j)^2 ) + pom;
    end
    % figure; plot(graf);

    % upsilon
    lm3 = 0;
    for j = 1:(n-1)
        ind = find(indL(:,j)>0);
        pomLtxxtL(j,j) = hat_L([j; ind],j)'*hat_xxt([j; ind],[j; ind])*hat_L([j; ind],j) + trace(diag(Dsi_lj(ind,j))*hat_xxt(ind,ind));
    end
    pomLtxxtL(n,n) = hat_xxt(n,n);
    for j = 1:n
        lm3 = lm3 - alpha(j)*log(beta(j)) - (1/2)*( psi(alpha(j)) - log(beta(j)) ) + (1/2)*hat_upsilon(j)*pomLtxxtL(j,j);
    end

    % l
    % lm4 v iteracich

    % varsigma
    % lm5 v iteracich

    if fixedSigmaL
        info.lm = lm1 + lm2 + lm3 + lm4; % exp
    else
        info.lm = lm1 + lm2 + lm3 + lm4 + lm5; % exp
%         display(num2str(lm1))
%         display(num2str(lm2))
%         display(num2str(lm3))
%         display(num2str(lm4))
%         display(num2str(lm5))
    end
%     display(num2str(info.lm));
end
% keyboard

% info.L = hat_L;
% info.varsigma = hat_varsigma;
info.ups = hat_upsilon;
info.l1 = diag(hat_L,-1);
% info.si_x = si_x;
% info.prior_si_x = inv(hat_L*diag(hat_upsilon)*hat_L' + pomLULt);

info.dsi_x = diag(si_x);

% figure; imagesc(inv(hat_L*diag(hat_upsilon)*hat_L' + pomLULt))
% keyboard
end